<?php

/**
 * Alert handler for invoices.
 */
class Waindigo_Invoices_AlertHandler_Invoice extends XenForo_AlertHandler_Abstract
{

    /**
     * Fetches the content required by alerts.
     *
     * @param array $contentIds
     * @param XenForo_Model_Alert $model Alert model invoking this
     * @param integer $userId User ID the alerts are for
     * @param array $viewingUser Information about the viewing user (keys:
     * user_id, permission_combination_id, permissions)
     *
     * @return array
     */
    public function getContentByIds(array $contentIds, $model, $userId, array $viewingUser)
    {
        /* @var $invoiceModel Waindigo_Invoices_Model_Invoice */
        $invoiceModel = $model->getModelFromCache('Waindigo_Invoices_Model_Invoice');

        return $invoiceModel->getInvoices(array(
            'invoice_id' => $contentIds
        ));
    } /* END getContentByIds */
}