<?php

class Waindigo_Invoices_CronEntry_RecurringInvoices
{

    static public function sendRecurringInvoices()
    {
        $db = XenForo_Application::getDb();

        $db->beginTransaction();

        $invoices = $db->fetchAll(
            $db->limit('
				SELECT * FROM `recurring_invoice_waindigo`
				WHERE invoice_date <= ?
			', 100, 0), date("Y-m-d", time()));

        /* @var $invoiceModel Waindigo_Invoices_Model_Invoice */
        $invoiceModel = XenForo_Model::create('Waindigo_Invoices_Model_Invoice');

        /* @var $recurringInvoiceModel Waindigo_Invoices_Model_Recurring_Invoice */
        $recurringInvoiceModel = XenForo_Model::create('Waindigo_Invoices_Model_Recurring_Invoice');

        foreach ($invoices as $invoice) {
            /*$oldInvoice = $invoiceModel->getInvoice(
                array(
                    'user_id' => $invoice['user_id'],
                    'to_user_id' => $invoice['to_user_id'],
                    'invoice_date' => $invoice['invoice_date']
                ));*/

            /* @var $invoiceWriter Waindigo_Invoices_DataWriter_Invoice */
            $invoiceWriter = XenForo_DataWriter::create('Waindigo_Invoices_DataWriter_Invoice');
            /*if (!empty($oldInvoice)) {
                $invoiceWriter->setExistingData($oldInvoice['invoice_id']);
            }*/
            $invoiceWriter->bulkSet(
                array(
                    'user_id' => $invoice['user_id'],
                    'username' => $invoice['username'],
                    'name' => $invoice['name'],
                    'address' => $invoice['address'],
                    'to_user_id' => $invoice['to_user_id'],
                    'to_username' => $invoice['to_username'],
                    'to_name' => $invoice['to_name'],
                    'to_address' => $invoice['to_address'],
                    'invoice_date' => $invoice['invoice_date']
                ));

            $invoiceItems = $db->fetchAll(
                '
					SELECT * FROM `recurring_invoice_item_waindigo`
					WHERE invoice_id = ?
				', $invoice['invoice_id']);

            $i = 0;
            foreach ($invoiceItems as $invoiceItem) {
                $invoiceItemFields[$i] = $db->fetchAll(
                    '
						SELECT * FROM `recurring_invoice_item_field_waindigo`
						WHERE invoice_item_id = ?
						', $invoiceItem['invoice_item_id']);

                $i++;
            }

            $invoiceWriter->setInvoiceItems($invoiceItems, $invoiceItemFields);

            $invoiceWriter->save();

            $time = strtotime($invoice['invoice_date']);
            switch ($invoice['length_unit']) {
                case 'day':
                    $time = mktime(0, 0, 0, date('m', $time), date('d', $time) + $invoice['length_amount'],
                        date('Y', $time));
                    break;
                case 'month':
                    $time = mktime(0, 0, 0, date('m', $time) + $invoice['length_amount'], date('d', $time),
                        date('Y', $time));
                    break;
                case 'year':
                    $time = mktime(0, 0, 0, date('m', $time), date('d', $time),
                        date('Y', $time) + $invoice['length_amount']);
                    break;
                default:
                    $time = 0;
                    break;
            }

            if ($time) {
                $invoice['invoice_date'] = date("Y-m-d", $time);
                /*$oldRecurringInvoice = $recurringInvoiceModel->getInvoice(
                    array(
                        'user_id' => $invoice['user_id'],
                        'to_user_id' => $invoice['to_user_id'],
                        'invoice_date' => $invoice['invoice_date'],
                        'length_amount' => $invoice['length_amount'],
                        'length_unit' => $invoice['length_unit']
                    ));
                if (!empty($oldRecurringInvoice)) {
                    $db->query(
                        'UPDATE `recurring_invoice_item_waindigo` SET invoice_id = ?
						WHERE invoice_id = ?',
                        array(
                            $oldRecurringInvoice['invoice_id'],
                            $invoice['invoice_id']
                        ));
                    $db->delete('recurring_invoice_waindigo', 'invoice_id = ' . $invoice['invoice_id']);
                } else {*/
                    $db->query('UPDATE `recurring_invoice_waindigo` SET invoice_date = ?
							WHERE invoice_id = ?',
                        array(
                            $invoice['invoice_date'],
                            $invoice['invoice_id']
                        ));
                //}
            } else {
                /* @var $dw Waindigo_Invoices_DataWriter_Recurring_Invoice */
                $dw = XenForo_DataWriter::create('Waindigo_Invoices_DataWriter_Recurring_Invoice');
                $dw->setExistingData($invoice['invoice_id']);
                $dw->delete();
            }
        }

        $db->commit();
    }
}