<?php

class Waindigo_Invoices_DataWriter_Invoice_Item_Field extends XenForo_DataWriter
{

    protected function _getFields()
    {
        return array(
            'invoice_item_field_waindigo' => array(
                'invoice_item_field_id' => array(
                    'type' => self::TYPE_UINT,
                    'autoIncrement' => true
                ),
                'invoice_item_id' => array(
                    'type' => self::TYPE_UINT,
                    'required' => true
                ),
                'field_name' => array(
                    'type' => self::TYPE_STRING,
                    'required' => true
                ),
                'field_value' => array(
                    'type' => self::TYPE_STRING,
                    'default' => ''
                ),
                'field_text' => array(
                    'type' => self::TYPE_STRING,
                    'default' => ''
                )
            )
        );
    } /* END _getFields */

    protected function _getExistingData($data)
    {
        if (!$id = $this->_getExistingPrimaryKey($data)) {
            return false;
        }

        /*
         * @var $invoiceItemFieldModel
         * Waindigo_Invoices_Model_Invoice_Item_Field
         */
        $invoiceItemFieldModel = $this->getModelFromCache('Waindigo_Invoices_Model_Invoice_Item_Field');

        return array(
            'invoice_item_field_waindigo' => $invoiceItemFieldModel->getInvoiceItemFieldById($id)
        );
    } /* END _getExistingData */

    protected function _getUpdateCondition($tableName)
    {
        return 'invoice_item_field_id = ' . $this->_db->quote($this->getExisting('invoice_item_field_id'));
    } /* END _getUpdateCondition */
}