<?php

class Waindigo_Invoices_DataWriter_Recurring_Invoice extends Waindigo_Invoices_DataWriter_Invoice
{

    protected $_invoiceItemDataWriter = 'Waindigo_Invoices_DataWriter_Recurring_Invoice_Item';

    protected function _getFields()
    {
        return array(
            'recurring_invoice_waindigo' => array(
                'invoice_id' => array(
                    'type' => self::TYPE_UINT,
                    'autoIncrement' => true
                ),
                'invoice_number' => array(
                    'type' => self::TYPE_UINT,
                    'autoIncrement' => true
                ),
                'user_id' => array(
                    'type' => self::TYPE_UINT,
                    'required' => true
                ),
                'username' => array(
                    'type' => self::TYPE_STRING,
                    'required' => true
                ),
                'name' => array(
                    'type' => self::TYPE_STRING,
                    'required' => true
                ),
                'address' => array(
                    'type' => self::TYPE_STRING,
                    'default' => ''
                ),
                'to_user_id' => array(
                    'type' => self::TYPE_UINT,
                    'required' => true
                ),
                'to_username' => array(
                    'type' => self::TYPE_STRING,
                    'required' => true
                ),
                'to_name' => array(
                    'type' => self::TYPE_STRING,
                    'required' => true
                ),
                'to_address' => array(
                    'type' => self::TYPE_STRING,
                    'default' => ''
                ),
                'amount' => array(
                    'type' => self::TYPE_UINT,
                    'default' => 0
                ),
                'invoice_date' => array(
                    'type' => self::TYPE_STRING,
                    'required' => true
                ),
                'length_amount' => array(
                    'type' => self::TYPE_UINT,
                    'default' => 0
                ),
                'length_unit' => array(
                    'type' => self::TYPE_STRING,
                    'default' => '',
                    'allowedValues' => array(
                        'day',
                        'month',
                        'year',
                        ''
                    )
                ),
                'active' => array(
                    'type' => self::TYPE_BOOLEAN,
                    'default' => 1
                )
            )
        );
    } /* END _getFields */

    protected function _getExistingData($data)
    {
        if (!$id = $this->_getExistingPrimaryKey($data)) {
            return false;
        }

        /* @var $customerModel Waindigo_Invoices_Model_Recurring_Invoice */
        $invoiceModel = $this->getModelFromCache('Waindigo_Invoices_Model_Recurring_Invoice');

        return array(
            'recurring_invoice_waindigo' => $invoiceModel->getInvoiceById($id)
        );
    } /* END _getExistingData */

    /**
     * Updates the customer invoice count.
     */
    protected function _updateCustomerInvoiceCount()
    {
        /*
         * $this->_db->query(' UPDATE and_customer SET recurring_invoice_count =
         * recurring_invoice_count + 1 WHERE customer_id = ? ',
         * $this->get('from_customer_id')); $customerId =
         * $this->get('from_customer_id'); $this->_db->query(' UPDATE
         * and_customer SET recurring_invoice_count = recurring_invoice_count +
         * 1 WHERE customer_id = ? ', $this->get('to_customer_id'));
         */
    } /* END _updateCustomerInvoiceCount */

    protected function _updateNextInvoiceNumber()
    {
        /*
         * if ($this->isUpdate()) { $this->_db->query(' UPDATE and_customer SET
         * next_recurring_invoice_number =
         * GREATEST(next_recurring_invoice_number,
         * '.($this->get('invoice_number')+1).') WHERE customer_id = ? ',
         * $this->get('from_customer_id')); } else { $this->_db->query(' UPDATE
         * and_customer SET next_recurring_invoice_number =
         * GREATEST(next_recurring_invoice_number+1,
         * '.($this->get('invoice_number')+1).') WHERE customer_id = ? ',
         * $this->get('from_customer_id')); }
         */
    } /* END _updateNextInvoiceNumber */

    protected function _alertUser()
    {
        // do nothing
    } /* END _alertUser */

    protected function _getNextInvoiceNumber()
    {
        return $this->_getInvoiceModel()->getNextInvoiceNumberForUserId($this->get('user_id'));
    } /* END _getNextInvoiceNumber */

    /**
     *
     * @return Waindigo_Invoices_Model_Recurring_Invoice
     */
    protected function _getInvoiceModel()
    {
        return $this->getModelFromCache('Waindigo_Invoices_Model_Recurring_Invoice');
    } /* END _getInvoiceModel */
}