<?php

class Waindigo_Invoices_Install_Controller extends Waindigo_Install
{

    protected $_resourceManagerUrl = 'http://xenforo.com/community/resources/invoices-by-waindigo.3337/';

    protected function _getTables()
    {
        return array(
            'invoice_waindigo' => array(
                'invoice_id' => 'INT(8) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY',
                'invoice_number' => 'INT(8) UNSIGNED ZEROFILL NOT NULL DEFAULT 0',
                'user_id' => 'INT(10) UNSIGNED NOT NULL',
                'username' => 'VARCHAR(255) NOT NULL',
                'name' => 'VARCHAR(255) NOT NULL',
                'address' => 'VARCHAR(255) NOT NULL DEFAULT \'\'',
                'to_user_id' => 'INT(10) UNSIGNED NOT NULL',
                'to_username' => 'VARCHAR(255) NOT NULL',
                'to_name' => 'VARCHAR(255) NOT NULL',
                'to_address' => 'VARCHAR(255) NOT NULL DEFAULT \'\'',
                'amount' => 'INT(10) NOT NULL DEFAULT 0',
                'invoice_date' => 'DATE NOT NULL',
                'paid_state' => 'ENUM(\'paid\',\'uncleared\',\'unpaid\') NOT NULL DEFAULT \'unpaid\'',
                'paid_date' => 'INT(10) UNSIGNED NOT NULL DEFAULT 0',
                'payment_method' => 'VARCHAR(25) NOT NULL DEFAULT \'\'',
                'invoice_state' => 'ENUM(\'visible\',\'draft\',\'deleted\') NOT NULL DEFAULT \'visible\''
            ),
            'invoice_item_waindigo' => array(
                'invoice_item_id' => 'INT(10) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY',
                'invoice_id' => 'INT(8) UNSIGNED NOT NULL',
                'description' => 'VARCHAR(255) NOT NULL',
                'cost_amount' => 'DOUBLE(15, 2) NOT NULL DEFAULT \'0.00\'',
                'quantity' => 'DOUBLE(7, 3) UNSIGNED NOT NULL DEFAULT \'0.000\''
            ),
            'invoice_item_field_waindigo' => array(
                'invoice_item_field_id' => 'INT(10) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY',
                'invoice_item_id' => 'INT(10) UNSIGNED NOT NULL',
                'field_name' => 'VARCHAR(255) NOT NULL',
                'field_value' => 'VARCHAR(255) NOT NULL DEFAULT \'\'',
                'field_text' => 'VARCHAR(255) NOT NULL DEFAULT \'\''
            ),
            'recurring_invoice_waindigo' => array(
                'invoice_id' => 'INT(8) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY',
                'invoice_number' => 'INT(8) UNSIGNED ZEROFILL NOT NULL',
                'user_id' => 'INT(10) UNSIGNED NOT NULL',
                'username' => 'VARCHAR(255) NOT NULL',
                'name' => 'VARCHAR(255) NOT NULL',
                'address' => 'VARCHAR(255) NOT NULL',
                'to_user_id' => 'INT(10) UNSIGNED NOT NULL',
                'to_username' => 'VARCHAR(255) NOT NULL',
                'to_name' => 'VARCHAR(255) NOT NULL',
                'to_address' => 'VARCHAR(255) NOT NULL',
                'amount' => 'INT(10) NOT NULL DEFAULT 0',
                'invoice_date' => 'DATE NOT NULL',
                'length_amount' => 'tinyint NOT NULL DEFAULT \'1\'',
                'length_unit' => 'enum(\'day\',\'month\',\'year\',\'\') NOT NULL DEFAULT \'\'',
                'active' => 'TINYINT(3) UNSIGNED NOT NULL DEFAULT \'1\''
            ),
            'recurring_invoice_item_waindigo' => array(
                'invoice_item_id' => 'INT(10) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY',
                'invoice_id' => 'INT(8) UNSIGNED NOT NULL',
                'description' => 'VARCHAR(255) NOT NULL',
                'cost_amount' => 'DOUBLE(15, 2) NOT NULL DEFAULT \'0.00\'',
                'quantity' => 'DOUBLE(7, 3) UNSIGNED NOT NULL DEFAULT \'0.000\''
            ),
            'recurring_invoice_item_field_waindigo' => array(
                'invoice_item_field_id' => 'INT(10) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY',
                'invoice_item_id' => 'INT(10) UNSIGNED NOT NULL',
                'field_name' => 'VARCHAR(255) NOT NULL',
                'field_value' => 'VARCHAR(255) NOT NULL DEFAULT \'\'',
                'field_text' => 'VARCHAR(255) NOT NULL DEFAULT \'\''
            )
        );
    } /* END _getTables */

    protected function _getUniqueKeys()
    {
        return array(
            'invoice_item_field_waindigo' => array(
                'invoiceItemId_fieldName' => array(
                    'invoice_item_id',
                    'field_name'
                )
            ),
            'recurring_invoice_item_field_waindigo' => array(
                'invoiceItemId_fieldName' => array(
                    'invoice_item_id',
                    'field_name'
                )
            )
        );
    } /* END _getUniqueKeys */

    protected function _getContentTypes()
    {
        return array(
            'invoice' => array(
                'addon_id' => 'Waindigo_Invoices',
                'fields' => array(
                    'alert_handler_class' => 'Waindigo_Invoices_AlertHandler_Invoice'
                )
            )
        );
    } /* END _getContentTypes */
}