<?php

/**
 * Route prefix handler for invoices in the admin control panel.
 */
class Waindigo_Invoices_Route_PrefixAdmin_Invoices implements XenForo_Route_Interface
{

    /**
     * Match a specific route for an already matched prefix.
     *
     * @see XenForo_Route_Interface::match()
     */
    public function match($routePath, Zend_Controller_Request_Http $request, XenForo_Router $router)
    {
        $action = $router->resolveActionWithIntegerParam($routePath, $request, 'invoice_id');
        return $router->getRouteMatch('Waindigo_Invoices_ControllerAdmin_Invoice', $action, 'invoices');
    } /* END match */

    /**
     * Method to build a link to the specified page/action with the provided
     * data and params.
     *
     * @see XenForo_Route_BuilderInterface
     */
    public function buildLink($originalPrefix, $outputPrefix, $action, $extension, $data, array &$extraParams)
    {
        return XenForo_Link::buildBasicLinkWithIntegerParam($outputPrefix, $action, $extension, $data, 'invoice_id');
    } /* END buildLink */
}